package com.regnstad.csv2jsonosx.parser;

import org.json.me.JSONArray;

public class ParseHandler implements Runnable, CSV2JSONParser.ParsingObserver {

    private ParseObserver observer;
    private String csv;
    private boolean useHeadings;

    public ParseHandler(ParseObserver observer, String csv, boolean useHeadings) {
        this.observer = observer;
        this.csv = csv;
        this.useHeadings = useHeadings;
    }

    @Override
    public void run() {
        CSV2JSONParser parser = new CSV2JSONParser(ParseHandler.this, csv);
        parser.setUseHeadings(useHeadings);
        parser.convert();
    }

    @Override
    public void handleParsingSuccess(JSONArray jsonArray) {
        observer.handleParsedJSON(jsonArray);
    }

    @Override
    public void handleParsingError(String message) {
        observer.handleJSONParseError(message);
    }

    public interface ParseObserver {

        public void handleParsedJSON(JSONArray json);
        public void handleJSONParseError(String message);
    }
}
